=== debian/changelog ===
wsclean (3.6-3) unstable; urgency=medium

  [ Phil Wyett ]
  * Remove no longer needed 'Rules-Requires-Root: no'. Now is default behavior.

  [ Ole Streicher ]
  * Remove the use of local pybind11 from radler subpackage (Closes: #1113633)

 -- Ole Streicher <olebole@debian.org>  Mon, 29 Sep 2025 09:49:07 +0200

wsclean (3.6-2) unstable; urgency=medium

  * Fix FTBFS with gcc-15 (Closes: #1110674)

 -- Ole Streicher <olebole@debian.org>  Mon, 18 Aug 2025 20:47:01 +0200

wsclean (3.6-1) unstable; urgency=medium

  * New upstream version 3.6
  * Rediff patches
  * Fix d/u/metadata syntax
  * Push Standards-Version to 4.7.2, no changes needed
  * Don't fetch XTensor from git
  * New build dependency libxtensor-blas-dev

 -- Ole Streicher <olebole@debian.org>  Tue, 18 Mar 2025 13:59:29 +0100
