=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/archive\/v(\d\S+)\/wsclean.*\.tar\.gz/wsclean-$1\.tar\.gz/g \
  https://gitlab.com/aroffringa/wsclean/-/tags?sort=updated_desc .*/archive/v(\d\S+)/.*\.tar\.gz.*
